#include <iostream>
#include <cstring>
#include <vector>
#include <sstream>
#include <fstream>

using namespace std;

struct stud {
	string name;
	string lastname;
	string otch;
	int group;
	int marks[5];
};

string IntToString(int num) {
	stringstream mem;
	string str;
	mem << num;
	mem >> str;
	return str;
}
int StringToInt(string str) {
	stringstream mem;
	int num;
	mem << str;
	mem >> num;
	return num;
}

vector<string> split(string str, char lim) {
	vector<string> v;
	for(int i=0; i<str.size(); i++) {
		if(str[i]==lim) {
			string temp = str.substr(0,i);
			v.push_back(temp);
			str.erase(0,i+1);
			i=0;
		}
	}
	v.push_back(str);
	return v;
}

string buildString(vector<stud> &v, char fieldSeparator=',', char stringSeparator='\n') {
	string buff;
	for(int i=0; i<v.size(); i++) {
		buff+=v[i].name+fieldSeparator;
		buff+=v[i].lastname+fieldSeparator;
		buff+=v[i].otch+fieldSeparator;
		buff+=IntToString(v[i].group)+fieldSeparator;
		for(int j=0; j<4; j++) buff+=IntToString(v[i].marks[j])+fieldSeparator;
		buff+=IntToString(v[i].marks[4]);
		buff+=stringSeparator;
	}
	return buff;
}

bool existsFile(string name) {
	ifstream fi;
	fi.open(name.data());
	if(fi.fail()) return false;
	fi.close();
	return true;
}

bool createFile(string name) {
	if(existsFile(name)) return true;
	ofstream of;
	of.open(name.data());
	if(of.fail()) return false;
	of.close();
	return true;
}

int fileLenght(string name) {
	if(!existsFile(name)) return 0;
	ifstream fi;
	fi.open(name.data());
	fi.seekg(0, ios::end);
	int lenght = fi.tellg();
	fi.close();
	return lenght;
}
bool emptyFile(string name) {
	return !fileLenght(name);
}

bool writeToFile(string name, string text) {
	ofstream of;
	of.open(name.data(), ios::trunc);
	if(of.fail()) return false;
	of << text;
	of.close();
	return true;
}

/*Читает из файла текст*/
string readFromFile(string name) {
	string str="";
	if(!existsFile(name) || emptyFile(name)) {
		createFile(name);
		return str;
	}
	ifstream fi;
	fi.open(name.data());
	char temp='0';
	fi.seekg(0);
	for(int i=0; i<fileLenght(name); i++) {
		temp = fi.get();
		str+=temp;
	}
	fi.close();
	return str;
}

bool getData(string name, vector<stud> &v) {
	string buff = readFromFile(name);
	if(buff == "") return false;
	vector<string> sV = split(buff, '\n');
	sV.pop_back();
	/*cout << "---Debug---" << endl;
	for(int i=0; i<sV.size(); i++) {
		cout << sV[i];
	}*/
	//cout << endl;
	for(int i=0; i<sV.size(); i++) {
		//cout << sV[i] << endl;
		/*Проблема заключается в том, что в вектор sV попадают какие-то значения (видимо, пустая строка). В результате вектор fV ловит эти значения, но их всего два. В результате при попытке
		заполнения структуры stud возникает ошибка выхода за границы массива. Задача - проверить так ли это (что представляют собой эти значения). Проверять нужно так: (int)((fV[i].data())[0])
		Если не будет хватать времени, то воспользоваться методом pop_back() в функции split.*/
		vector<string> fV = split(sV[i], ',');
		//cout << "==>";
		//for(int j=0; j<fV.size(); j++) cout << fV[j] << " ";
		//cout << endl;
		stud temp;
		if(fV.empty()) break;
		temp.name = fV[0];
		temp.lastname = fV[1];
		temp.otch = fV[2];
		temp.group = StringToInt(fV[3]);
		for(int j=0; j<5; j++) temp.marks[j] = StringToInt(fV[4+j]);
		v.push_back(temp);
	}
	return true;
}

bool saveData(string name, vector<stud> &v) {
	string buff = buildString(v);
	return writeToFile(name, buff);
}

void addStud(vector<stud> &studVector, string name, string lastname, string otch, int group, int marks[5]) {
	stud temp = {name, lastname, otch, group, marks[0], marks[1], marks[2], marks[3], marks[4]};
	studVector.push_back(temp);
}
stud enterStud() {
	stud temp;
	cout << "Enter name of the student: ";
	cin >> temp.name;
	cout << "Enter lastname of the student: ";
	cin >> temp.lastname;
	cout << "Enter otchestvo of the student: ";
	cin >> temp.otch;
	cout << "Enter group of the student: ";
	cin >> temp.group;
	cout << "Enter marks of the student: ";
	cin >> temp.marks[0] >> temp.marks[1] >> temp.marks[2] >> temp.marks[3] >> temp.marks[4];
	return temp;
}
void addStud(vector<stud> &studVector) {
	/*stud temp;
	cout << "Enter name of the student: ";
	cin >> temp.name;
	cout << "Enter lastname of the student: ";
	cin >> temp.lastname;
	cout << "Enter otchestvo of the student: ";
	cin >> temp.otch;
	cout << "Enter group of the student: ";
	cin >> temp.group;
	cout << "Enter marks of the student: ";
	cin >> temp.marks[0] >> temp.marks[1] >> temp.marks[2] >> temp.marks[3] >> temp.marks[4];*/
	stud temp = enterStud();
	studVector.push_back(temp);
	cout << "---Successfully done!---" << endl;
}
void listStud(vector<stud> &studVector) {
	if(studVector.empty()) cout << "No students has been detected!" << endl;
	cout << "--------------Students--------------" << endl;
	for(int i=0; i<studVector.size(); i++) {
		cout << endl << "---Stud №" << i+1 << endl << endl;
		cout << "\tNumber of Group: " << studVector[i].group << endl;
		cout << "\tName: " << studVector[i].name << endl;
		cout << "\tLastname: " << studVector[i].lastname << endl;
		cout << "\tOtchestvo: " << studVector[i].otch << endl;
		cout << "\tLastname: ";
		for(int j=0; j<5; j++) {
			cout << studVector[i].marks[j] << " ";
		}
		cout << endl;
	}
	cout << "------------------------------------" << endl << endl;
	cout << "---Total: " << studVector.size() << " students" << endl;
	cout << "------------------------------------" << endl;
}
void deleteStud(vector<stud> &studVector) {
	if(studVector.empty()) {
		cout << "No students has been detected!" << endl;
		return;
	}
	listStud(studVector);
	int num;
	string ask;
	cout << "Enter number of the student, which you want to remove: ";
	cin >> num;
	if(num <=0 || num>studVector.size()) {
		cout << "Can not find student with such index" << endl;
		return;
	}
	num -= 1;
	cout << "Do you really want to remove the student with next params?" << endl << "№" << num << endl << "Name: " << studVector[num].name << endl
	<< "Lastname: " << studVector[num].lastname << endl
	<< "Otchestvo: " << studVector[num].otch << endl
	<< "Number of group: " << studVector[num].group << endl
	<< "Marks: ";
	for(int i=0; i<5; i++) cout << studVector[num].marks[i] << " ";
	cout << endl;
	cout << "(y/n): ";
	cin >> ask;
	if(ask!="y") return;
	studVector.erase(studVector.begin()+num);
	cout << "Student has been successfully removed!" << endl;
}
void editStud(vector<stud> &studVector) {
	/*Есть ли студенты*/
	if(studVector.empty()) {
		cout << "No students has been detected!" << endl;
		return;
	}
	/*Выводим студентов*/
	listStud(studVector);
	/*Вводим номер студента*/
	int num;
	cout << "Enter number of the student, which you want edit: ";
	cin >> num;
	/*Проверяем корректность ввода*/
	if(num<=0 || num>studVector.size()) {
		cout << "Can not find student with such index" << endl;
		return;
	}
	/*Уменьшаем номер на 1, для того, чтобы синхронизировать его с индексами вектора*/
	num -= 1;
	/*Какие поля будем изменять*/
	string ans;
	cout << "What properties do you want to edit? ('name', 'lastname', 'otch', 'group', 'marks', '*' - all): ";
	cin >> ans;
	/*Если все поля*/
	if(ans == "*") {
		/*cout << "Enter name of the student: ";
		cin >> studVector[num].name;
		cout << "Enter age of the student: ";
		cin >> studVector[num].age;
		cout << "---Successfully done!---" << endl;*/
		stud temp = enterStud();
		studVector[num] = temp;
		cout << "---Successfully done!---" << endl;
	/*Если одно из полей*/
	} else {
		/*Если мы будем изменять только имя*/
		if(ans=="name") {
			cout << "Enter " << ans << " of the student: ";
			cin >> studVector[num].name;
		/*Только возраст*/
		} else if(ans=="lastname") {
			cout << "Enter " << ans << " of the student: ";
			cin >> studVector[num].lastname;
		/*Если ошиблись и ввели не существующее поле*/
		} else if(ans=="otch") {
			cout << "Enter " << ans << " of the student: ";
			cin >> studVector[num].otch;
		/*Если ошиблись и ввели не существующее поле*/
		}
		else if(ans=="group") {
			cout << "Enter " << ans << " of the student: ";
			cin >> studVector[num].group;
		/*Если ошиблись и ввели не существующее поле*/
		}
		else if(ans=="marks") {
			cout << "Enter " << ans << " of the student: ";
			for(int i=0; i<5; i++) cin >> studVector[num].marks[i];
		/*Если ошиблись и ввели не существующее поле*/
		}
		else {
			cout << "No matching fields!" << endl;
			return;
		}
		cout << "---Successfully done!---" << endl;
	}
}

bool arrayHave(int num, int* arr, size_t size) {
	for(int i=0; i<size; i++) {
		if(*(arr+i)==num) return true;
	}
	return false;
}

void printMarks(int* arr) {
	for(int i=0; i<5; i++) {
		cout << arr[i] << " ";
	}
	cout << endl;
}

void badList(vector<stud> &v) {
	bool found=false;
	for(int i=0; i<v.size(); i++) {
		if(arrayHave(2,v[i].marks,5)) {
			cout << "Student by number: " << (i+1) << endl;
			cout << "---Group: " << v[i].group << endl;
			cout << "---Name: " << v[i].name << endl;
			cout << "---Lastname: " << v[i].lastname << endl;
			cout << "---Otch: " << v[i].otch << endl;
			cout << "---Marks: ";
			printMarks(v[i].marks);
			found = true;
		}
		cout << endl;
	}
	if(!found) cout << "No such students have been detected!!!" << endl;
}

void goodList(vector<stud> &v) {
	bool found = false;
	for(int i=0; i<v.size(); i++) {
		if(!arrayHave(1,v[i].marks,5) && !arrayHave(2,v[i].marks,5) && !arrayHave(3,v[i].marks,5)) {
			cout << "Student by number: " << (i+1) << endl;
			cout << "---Group: " << v[i].group << endl;
			cout << "---Name: " << v[i].name << endl;
			cout << "---Lastname: " << v[i].lastname << endl;
			cout << "---Otch: " << v[i].otch << endl;
			cout << "---Marks: ";
			printMarks(v[i].marks);
			found = true;
		}
		cout << endl;
	}
	if(!found) cout << "No such students have been detected!!!" << endl;
}

double middleMark(int* arr) {
	double ball=0;
	for(int i=0; i<5; i++) {
		ball+=*(arr+i);
	}
	return ball/5;
}

void sortByMarks(vector<stud> &v) {
	for(int i=v.size()-1; i>=0; i--) {
		for(int j=0; j<i; j++) {
			if(middleMark(v[j].marks)<middleMark(v[j+1].marks)) {
				stud temp = v[j];
				v[j] = v[j+1];
				v[j+1] = temp;
			}
		}
	}
}

void sortByGroup(vector<stud> &v) {
	for(int i=v.size()-1; i>=0; i--) {
		for(int j=0; j<i; j++) {
			if(v[j].group>v[j+1].group) {
				stud temp = v[j];
				v[j] = v[j+1];
				v[j+1] = temp;
			}
		}
	}
}

void sortByName(vector<stud> &v) {
	for(int i=v.size()-1; i>=0; i--) {
		for(int j=0; j<i; j++) {
			if(v[j].name.compare(v[j+1].name)==1) {
				stud temp = v[j];
				v[j] = v[j+1];
				v[j+1] = temp;
			}
		}
	}
}

void sortByLastName(vector<stud> &v) {
	for(int i=v.size()-1; i>=0; i--) {
		for(int j=0; j<i; j++) {
			if(v[j].lastname.compare(v[j+1].lastname)==1) {
				stud temp = v[j];
				v[j] = v[j+1];
				v[j+1] = temp;
			}
		}
	}
}

void sortByOtch(vector<stud> &v) {
	for(int i=v.size()-1; i>=0; i--) {
		for(int j=0; j<i; j++) {
			if(v[j].otch.compare(v[j+1].otch)==1) {
				stud temp = v[j];
				v[j] = v[j+1];
				v[j+1] = temp;
			}
		}
	}
}

void printMiddle(vector<stud> &v) {
	for(int i=0; i<v.size(); i++) {
		cout << "Middle of: ";
		printMarks(v[i].marks);
		cout << middleMark(v[i].marks) << endl << endl;
	}
}

void sort(vector<stud> &v) {
	string key="";
	cout << "By what field do you want to sort students (group, name, lastname, otch, marks)?:";
	cin >> key;
	if(key=="group") {
		sortByGroup(v);
	} else if(key=="name") {
		sortByName(v);
	} else if(key=="lastname") {
		sortByLastName(v);
	} else if(key=="otch") {
		sortByOtch(v);
	} else if(key=="marks") {
		sortByMarks(v);
	} else {
		cout << "Can not understand your command!!!" << endl;
		return;
	}
	cout << "Successfully done!" << endl;
}


void help() {
	cout << "Enter \"list\" to see list of the students" << endl << "Enter \"add\" to add the student" << endl << "Enter \"remove\" to remove the student" << 
	endl << "Enter \"edit\" to edit the student" << endl
	<< "Enter \"badList\" to print bad list of students from data base" << endl
	<< "Enter \"goodList\" to print good list of students from data base" << endl
	<< "Enter \"sort\" to sort students you want" << endl
	<< "Enter \"printMiddle\" to print middle balls of students" << endl
	<< "Enter \"save\" to save your data base" << endl
	<< "Enter \"reload\" to reload your data base from file again" << endl
	<< "Enter \"help\" to see this text again" << endl << endl;
}
int main() {
	/*string names[] = {
		"Ivanov",
		"Petrov",
		"Sidorov"
	};
	string lastnames[] = {
		"LIvanov",
		"LPetrov",
		"LSidorov"
	};
	string otch[] = {
		"OIvanov",
		"OPetrov",
		"OSidorov"
	};
	int numbers[] = {
		1,2,3
	};
	int marks[][5] = {
		{2,3,4,5,4},
		{4,4,4,4,4},
		{5,5,5,5,5}
	};*/
	vector<stud> st;
	getData("data.txt",st);
	/*for(int i=0; i<sizeof(names)/sizeof(int); i++) {
		addStud(st,names[i],lastnames[i],otch[i],numbers[i],marks[i]);
	}*/
	listStud(st);
	help();
	/*vector<int> st;
	st.push_back(10);
	cout << st.back() << endl;*/
	string key="";
	do {
		cout << "What action do you want to do?: ";
		cin >> key;
		if(key=="add") {
			cout << "You selected action \"Add student\"" << endl;
			addStud(st);
		} else if(key=="list") {
			cout << "You selected action \"List of students\"" << endl;
			listStud(st);
		} else if(key=="remove") {
			cout << "You selected action \"Remove the student\"" << endl;
			deleteStud(st);
		} else if(key=="edit") {
			cout << "You selected action \"Edit student\"" << endl;
			editStud(st);
		} else if(key=="save") {
			if(saveData("data.txt",st)) {
				cout << "---Data Base has been successfully saved!!!---" << endl;
			}
		} else if(key=="reload") {
			st.clear();
			getData("data.txt",st);
			cout << "---Your base has been successfully reloaded!!!---" << endl;
		} 
		 else if(key=="badList") {
			cout << "---Bad List of the students---" << endl;
			badList(st);
		}
		 else if(key=="goodList") {
			cout << "---Good List of the students---" << endl;
			goodList(st);
		}
		else if(key=="sort") {
			cout << "---Sort---" << endl;
			sort(st);
		}
		else if(key=="printMiddle") {
			cout << "---Print Middle---" << endl << endl;
			printMiddle(st);
		}
		else if(key=="help") {
			cout << "---------Help---------" << endl;
			help();
		}
		else if(key=="exit") {
		} else {
			cout << "Can not understand you command" << endl;
		}
	} while(key!="exit");
	return 0;
}
